<template>
  <div id="edit-product_details">
    <section class="product-details">
      <section class="product-foto">
        <section>
          <img :src="this.localProduct.urlphoto" v-if="this.oldImg" />
          <img :src="this.localProduct.image.dataUrl" v-if="this.localProduct.hasImage" />
        </section>
        <section>
          <image-uploader
            :preview="false"
            :className="[
              'fileinput',
              { 'fileinput--loaded': localProduct.hasImage }
            ]"
            capture="environment"
            :debug="1"
            doNotResize="gif"
            :autoRotate="true"
            outputFormat="verbose"
            @input="setImage"
          ></image-uploader>
        </section>
      </section>
      <section class="promo">
        <v-btn small color="green" v-on:click="setPromo()" class="set-promo">promo</v-btn>
        <section v-show="this.localProduct.promos =='1'">Yeah , soy promo</section>
      </section>
      <section>
        <section class="name-input">
          <v-text-field type="text" v-model="localProduct.name"></v-text-field>
        </section>
        <section class="description-input">
          <span>Descripción:</span>

          <v-text-field type="text" v-model="localProduct.description"></v-text-field>
        </section>
        <section>
          <span>Precio:</span>

          <v-text-field type="number" v-model.number="localProduct.price" class="price-input"></v-text-field>
        </section>
        <section v-show="this.localProduct.promos =='1'">
          <span>Precio promo:</span>

          <v-text-field type="number" v-model.number="localProduct.new_price" class="price-input"></v-text-field>
        </section>
        <section>
          <span>Categoría:</span>
          <v-col class="d-flex" cols="12" sm="6">
            <v-select v-model="localProduct.category" :items="items" label="Categorias" dense></v-select>
          </v-col>
        </section>
      </section>
    </section>
    <section class="buttons">
      <v-btn small color="green" v-on:click="cancelEditingProduct()" class="cancel-edit">cancelar</v-btn>
      <v-btn small color="green" v-on:click="SaveChangedDetails()" class="SaveChangesButton">salvar</v-btn>
    </section>
  </div>
</template>

<script>
//import ImageUploader from "vue-image-upload-resize";

export default {
  name: 'EditProductDetails',
  components: {
    // ImageUploader
  },
  props: {
    product: {
      propType: Array,
      required: true
    },
    items: {
      propType: Array,
      required: true
    }
  },

  data() {
    return {
      localProduct: {},
      oldImg: true,
      promo: false
    }
  },

  mounted() {},
  watch: {
    product: {
      immediate: true,
      handler: function() {
        this.localProduct = JSON.parse(JSON.stringify(this.product))
      }
    }
  },

  methods: {
    async SaveChangedDetails() {
      this.$emit('save-new-details-event', this.localProduct)
    },

    setImage(output) {
      this.oldImg = false
      this.localProduct.hasImage = true
      this.localProduct.image = output
    },

    cancelEditingProduct() {
      this.$emit('cancel-edit-product-details-event')
    },
    setPromo() {
      console.log('soy promo manager')
      if (this.product.promos === '1' && this.localProduct.promos === '1') {
        console.log('case 1')
        this.localProduct.promos = '0'
      } else if (
        this.product.promos === '1' &&
        this.localProduct.promos === '0'
      ) {
        console.log('case 2')
        this.localProduct.promos = '1'
      } else if (
        this.product.promos === '0' &&
        this.localProduct.promos === '0'
      ) {
        console.log('case 3')
        this.localProduct.promos = '1'
      } else {
        console.log('case 4')
        this.localProduct.promos = '0'
      }
    }
  }
}
</script>


<style scoped>
.product-details {
  display: flex;

  justify-content: space-around;
}
img {
  height: 20rem;
  width: 20rem;
}
.buttons {
  margin-top: 6%;
}
.name-input,
.price-input,
.tag1-input,
.tag2-input,
.tag3-input,
.d-flex,
.description-input {
  margin-left: 22%;
  margin-right: 30%;
}
.d-flex {
  margin-left: 22%;
  margin-right: 30%;
}
.description-input {
  width: 60%;
  height: 20%;
}
.buttons {
  display: flex;

  justify-content: space-around;
}
.product-foto {
  margin-top: 10%;
}
</style>
